<!DOCTYPE html>
<html>

<head>
    <title>Optimization Method</title>
    <meta charset="utf-8">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" />
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>

<body>
    <br />
    <div class="container">
        <h2>Initialisation des données</h2>
        <div class="col-md-12" style="padding-left: 0;">
            <form name="data_entry" action="form.php" method="post" onsubmit="return validateForm();">
                <p>On donne ici les différentes variables, la fonction objective et les contraintes à résoudre.</p>
                <p>En premier, on a besoin du nom de toutes les variables. Il faut les mettre les unes à la suite des autres, séparées d'un espace.</p>
                <p id="no_name" class="hidden">Le nom des variables ne peut pas être nul.</p>
                <p id="invalid_name" class="hidden">Le nom des variables ne peut pas être un nombre.</p>
                <div class="form-group">
                    <label>Noms des variables</label>
                    <input type="text" name="name" value="x1 x2 x3" class="form-control" />
                </div>
                <p>
                    Maintenant, on a besoin de la fonction objective. On commence par savoir si elle est linéaire. On coche la case ci-dessous si elle n'est pas linéaire.
                </p>
                <div class="form-check">
                    <input type="hidden" name="linear_objective" value="0" />
                    <input type="checkbox" class="form-check-input" name="linear_objective" value="1" />
                    <label class="form-check-label">Fonction objective non linéaire</label>
                </div>
                <p>Si la fonction objective est linéaire, on entre les coefficients ci-dessous. Par exemple, si on étudie "3x1 + 2x2", on écrit "3 2 0". Les coefficients du vecteur sont séparés par un espace.</p>
                <p>Si la fonction objective n'est pas linéaire, alors on entre directement la formule, eg "3*x1*x1 + log(x2)".</p>
                <p id="no_objective" class="hidden">La fonction objective ne peut pas être nulle.</p>
                <p id="invalid_objective" class="hidden">Si la fonction objective est linéaire, alors il ne faut que des nombres.</p>
                <p id="invalidNumber_objective" class="hidden">Si la fonction objective est linéaire, alors il faut un vecteur ayant (nombre de variables) coefficients (cf exemple ci-dessus).</p>
                <div class="form-group">
                    <label>Fonction objective</label>
                    <input type="text" name="objective" value="3 2 0" class="form-control" value="" />
                </div>
                <p>
                    Ensuite, on passe aux contraintes d'égalités associées (celles du type "x1 + x2 + x3 = 9"). On écrit le nombre de contraintes d'égalités. On commence par savoir si les contraintes d'égalité sont linéaires</p>
                <div class="form-check">
                    <input type="hidden" name="linear_constraint" value="0" />
                    <input type="checkbox" class="form-check-input" name="linear_constraint" value="1" />
                    <label class="form-check-label">Contrainte(s) d'égalité non linéaire(s)</label>
                </div>
                <p>Si les contraintes sont linéaires, on entre les coefficients ci-dessous. Par exemple, si on étudie "x1 + x2 + x3 = 9", on écrit "1 1 1 9". Les coefficients du vecteur sont séparés par un espace.</p>
                <p>Si les contraintes ne sont pas linéaires, alors on entre directement la formule, eg "3*x1*x1 + log(x2) - 8 = 0". ATTENTION: il faut obligatoirement avoir "= 0" à droite.</p>
                <p id="invalid_constraint" class="hidden">Si les contraintes sont linéaires, alors il ne faut que des nombres.</p>
                <p id="invalidNumber_constraint" class="hidden">Si les contraintes sont linéaires, alors il faut une matrice ayant (nombre de variables + 1) colonnes (cf exemple ci-dessus).</p>
                <div class="form-group">
                    <label>Contraintes d'égalités</label>
                    <textarea type="text" rows="5" name="constraints" placeholder="1 1 1 9
0 5 5 11" class="form-control" value="">1 1 1 9
0 5 5 11</textarea>
                </div>
                <p>
                    Ici, on écrit toutes les contraintes d'inégalités de la forme "7 -x1 >= 0". On écrit alors "7 -x1".
                    <br/> ATTENTION: il faut obligatoirement avoir ">= 0" dans le membre de droite, quitte à faire les changements nécessaires.
                </p>
                <div class="form-group">
                    <label>Contraintes d'inégalités</label>
                    <textarea type="text" rows="5" name="inequality_constraint" placeholder="7 -x1
x1
x2" class="form-control">7 -x1
6 -x2
x1
x2</textarea>
                </div>
                <p>
                    Enfin, on donne une solution admissible du problème. On écrit les valeurs variables les unes à la suite des autres, séparées par un espace.
                    <br/> ATTENTION: on utilise le point pour la décimale.
                </p>
                <p id="no_feasible_solution" class="hidden">Il faut une solution admissible.</p>
                <p id="invalid_feasible_solution" class="hidden">Pour la solution admissible, il ne faut que des nombres.</p>
                <p id="invalidNumber_feasible_solution" class="hidden">Pour la solution admissible, il faut un vecteur ayant (nombre de variables) coefficients (cf exemple ci-dessus).</p>
                <div class="form-group">
                    <label>Solution admissible</label>
                    <input type="text" name="feasible_solution" value="6.80 2.43 -0.23" class="form-control" value="" />
                </div>
                <div class="form-group" align="center">
                    <input type="submit" name="submit" class="btn btn-info" value="Submit" />
                </div>
            </form>
        </div>
    </div>

    <script>
        function validateForm() {
            return notEmpty() && objectiveValidation("objective") && objectiveValidation("feasible_solution") && nameValidation() && constraintValidation();
            // return objectiveValidation("feasible_solution");
        }

        function notEmpty() {
            var fields = ["name", "objective", "feasible_solution"];
            var i, l = fields.length;
            var fieldname;
            for (var i = 0; i < l; i++) {
                fieldname = fields[i];
                if (document.forms["data_entry"][fieldname].value === "") {
                    document.getElementById("no_" + fieldname).className = "alert alert-danger";
                    document.querySelector("#no_" + fieldname).scrollIntoView({
                        behavior: 'smooth'
                    });
                    return false;
                } else {
                    document.getElementById("no_" + fieldname).className = "hidden";
                }
            }
            return true;
        }

        function nameValidation() {
            var fields = document.forms["data_entry"]["name"].value.trim().split(" ");
            var l = fields.length;
            for (var i = 0; i < l; i++) {
                if (!isNaN(fields[i])) {
                    document.getElementById("invalid_name").className = "alert alert-danger";
                    document.querySelector("#invalid_name").scrollIntoView({
                        behavior: 'smooth'
                    });
                    return false;
                } else {
                    document.getElementById("invalid_name").className = "hidden";
                }
            }
            return true;
        }

        function constraintValidation() {
            var checkbox = document.querySelector('input[name="linear_constraint"]:checked');
            var number_variables = document.forms["data_entry"]["name"].value.trim().split(" ").length;
            if (checkbox === null) {
                var constraints = document.forms["data_entry"]["constraints"].value.trim().split("\n");
                var m = constraints.length;
                for (var j = 0; j < m; j++) {
                    var constraint_j = constraints[j].trim().split(" ");
                    var l = constraint_j.length;
                    if (l !== (number_variables + 1)) {
                        document.getElementById("invalidNumber_constraint").className = "alert alert-danger";
                        document.querySelector("#invalidNumber_constraint").scrollIntoView({
                            behavior: 'smooth'
                        });
                        return false;
                    } else {
                        document.getElementById("invalidNumber_constraint").className = "hidden";
                    }
                    for (var i = 0; i < l; i++) {
                        if (isNaN(constraint_j[i])) {
                            document.getElementById("invalid_constraint").className = "alert alert-danger";
                            document.querySelector("#invalid_constraint").scrollIntoView({
                                behavior: 'smooth'
                            });
                            return false;
                        } else {
                            document.getElementById("invalid_constraint").className = "hidden";
                        }
                    }
                }
            }
            return true;
        }

        function objectiveValidation(field) {
            var checkbox = document.querySelector('input[name="linear_objective"]:checked');
            var number_variables = document.forms["data_entry"]["name"].value.trim().split(" ").length;
            if (checkbox === null || field === "feasible_solution") {
                var objective = document.forms["data_entry"][field].value.trim().split("\n").join(" ").split(" ");
                var l = objective.length;
                if (l !== number_variables) {
                    document.getElementById("invalidNumber_" + field).className = "alert alert-danger";
                    document.querySelector("#invalidNumber_" + field).scrollIntoView({
                        behavior: 'smooth'
                    });
                    return false;
                } else {
                    document.getElementById("invalidNumber_" + field).className = "hidden";
                }
                for (var i = 0; i < l; i++) {
                    if (isNaN(objective[i])) {
                        document.getElementById("invalid_" + field).className = "alert alert-danger";
                        document.querySelector("#invalid_" + field).scrollIntoView({
                            behavior: 'smooth'
                        });
                        return false;
                    } else {
                        document.getElementById("invalid_" + field).className = "hidden";
                    }
                }
            }
            return true;
        }
    </script>

</body>

</html>